VERSION 5.00
Object = "{D279A812-072C-11D5-B32C-0050DADF6C37}#1.0#0"; "SQLStudioDSQL.dll"
Begin VB.UserControl StatusWindow 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   2625
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9165
   ScaleHeight     =   2625
   ScaleWidth      =   9165
   Begin VB.CheckBox chkVerbose 
      Caption         =   "&Trace All"
      Height          =   375
      Left            =   5640
      TabIndex        =   0
      Top             =   720
      Width           =   975
   End
   Begin SQLSTUDIODSQLLibCtl.SQLStudioDSQLInput rtfSQL 
      Height          =   900
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   4575
      _cx             =   8070
      _cy             =   1587
      Text            =   $"StatusWindow.ctx":0000
      Readonly        =   -1  'True
      StatusBarVisible=   0   'False
      ToolBarVisible  =   -1  'True
      HighlightKeyAndCom=   0   'False
      CommentPrefixAtStartOfLine=   "//"
      KeyWordsCaseSensitive=   0   'False
      WordWrap        =   -1  'True
      ConvertWordWrapToLineBreak=   0   'False
      AutoIndent      =   0   'False
      LocalContextMenuVisible=   -1  'True
      NavigateOnDblclick=   0   'False
      SpacesOnIndent  =   2
      ChangeCaseMode  =   0
      ColorTextHighlight=   0
      ColorTextEditable=   0
      OLEDropMode     =   2
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Menu mnuStatusWindow 
      Caption         =   "&Status Window"
      NegotiatePosition=   2  'Middle
      Begin VB.Menu mnuTraceAll 
         Caption         =   "&Trace All"
      End
      Begin VB.Menu mnuSeperator1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuClearWindow 
         Caption         =   "&Clear"
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuSelectAll 
         Caption         =   "&Select All"
      End
   End
End
Attribute VB_Name = "StatusWindow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Form:       StatusWindow
'
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQLStudio
'
' description:  status window control of SQL Studio
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


Option Explicit
  
 
'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = ".StatusWindow"

'=========================================================================================
'    property:      globalInfo
'    description:   set a object of type GlobalInfo
'    arguments:     newGlobalInfo
'
'    return value:  /
'
'=========================================================================================
Public Property Set globalInfo(newGlobalInfo As globalInfo)
    On Error GoTo errP_SET_globalInfo

    Const FUNCTION_NAME = "P_SET globalInfo"
    
    Dim sName               As String
    Dim FontBold            As Boolean
    Dim FontItalic          As Boolean
    Dim FontStrikethrough   As Boolean
    Dim FontUnderline       As Boolean
    Dim FontSize            As Long

    Set m_oGlobalInfo = newGlobalInfo
    
    'Init
    sName = rtfSQL.Font.Name
    FontBold = rtfSQL.Font.Bold
    FontItalic = rtfSQL.Font.Italic
    FontSize = rtfSQL.Font.Size
    FontStrikethrough = rtfSQL.Font.Strikethrough
    FontUnderline = rtfSQL.Font.Underline

    m_oGlobalInfo.userProfile.getStatusFont sName, _
                                      FontBold, _
                                      FontItalic, _
                                      FontSize, _
                                      FontStrikethrough, _
                                      FontUnderline
    rtfSQL.Font.Name = sName
    rtfSQL.Font.Bold = FontBold
    rtfSQL.Font.Italic = FontItalic
    rtfSQL.Font.Size = FontSize
    rtfSQL.Font.Strikethrough = FontStrikethrough
    rtfSQL.Font.Underline = FontUnderline
    
    'rtfSQL.ColorTextEditable = m_oGlobalInfo.userProfile.forTextColorStatusWindow
    'rtfSQL.ColorTextHighlight = m_oGlobalInfo.userProfile.highlightColorStatusWindow
    
    rtfSQL.ReadOnly = False
    rtfSQL.Text = ""
    rtfSQL.ReadOnly = True

    rtfSQL.refreshFont
    
    'this will trigger the click event and set the menu trace all too!
    If m_oGlobalInfo.conMan.statusVerbose Then
        chkVerbose.Value = vbChecked
    Else
        chkVerbose.Value = vbUnchecked
    End If

    
    Exit Property

errP_SET_globalInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Sub chkVerbose_Click()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "chkVerbose_Click"
        
    If chkVerbose.Value = vbChecked Then
    
        m_oGlobalInfo.userProfile.statusVerbose = True
        m_oGlobalInfo.conMan.statusVerbose = True
        
        mnuTraceAll.Checked = True
    Else
        m_oGlobalInfo.userProfile.statusVerbose = False
        m_oGlobalInfo.conMan.statusVerbose = False
        
        mnuTraceAll.Checked = False
    End If
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuTraceAll_Click()
 On Error GoTo errmnuTraceAll_Click

    Const FUNCTION_NAME = "mnuTraceAll_Click"
    
    mnuTraceAll.Checked = Not mnuTraceAll.Checked
    
    If mnuTraceAll.Checked = True Then
    
        m_oGlobalInfo.userProfile.statusVerbose = True
        m_oGlobalInfo.conMan.statusVerbose = True
        
        chkVerbose.Value = vbChecked
    Else
        m_oGlobalInfo.userProfile.statusVerbose = False
        m_oGlobalInfo.conMan.statusVerbose = False
        
        chkVerbose.Value = vbUnchecked
    End If
    
    Exit Sub
    
errmnuTraceAll_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub UserControl_Initialize()
    On Error GoTo errUserControl_Initialize
    
    Const FUNCTION_NAME = "UserControl_Initialize"

    'text limt 1MB
    rtfSQL.textLimit = 1048576
    rtfSQL.usageType = 1
    
 
    Exit Sub
    
errUserControl_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._MouseMove
'    description:   Occurs when the user moves the mouse
'    arguments:     [in] Button, An integer that corresponds to
'                               the state of the mouse buttons in which
'                               a bit is set if the button is down.
'                   [in] shift, An integer that corresponds to the
'                               state of the SHIFT, CTRL, and ALT keys.
'                   [in] x; y,  a number that specifies
'                               the current location of the mouse pointer
'
'    return value:  /
'
'=========================================================================================
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    On Error GoTo errUserControl_MouseMove

    Const FUNCTION_NAME = "UserControl_MouseMove"
    
    If m_oGlobalInfo Is Nothing Then Exit Sub

    Exit Sub

errUserControl_MouseMove:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub UserControl_Resize()
    On Error GoTo errUserControl_Resize
    
    Const FUNCTION_NAME = "UserControl_Resize"
    
    rtfSQL.Left = 1 * Screen.TwipsPerPixelX
    rtfSQL.Top = 2 * Screen.TwipsPerPixelY
    rtfSQL.Width = UserControl.ScaleWidth - 2 * Screen.TwipsPerPixelX
    rtfSQL.Height = UserControl.ScaleHeight - 2 * Screen.TwipsPerPixelX
    
    chkVerbose.Top = rtfSQL.Top - 5 * Screen.TwipsPerPixelX
    chkVerbose.Left = rtfSQL.Left + rtfSQL.Width - chkVerbose.Width - 4 * Screen.TwipsPerPixelX

    Exit Sub
    
errUserControl_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Public Property Get protWindow() As Object
    On Error GoTo errGetProtwindow
    
    Const FUNCTION_NAME = "getProtwindow"
    
    Set protWindow = rtfSQL

    Exit Property
    
errGetProtwindow:
    internalError Err, MODULE_NAME, FUNCTION_NAME

End Property
'=========================================================================================
'    function:      ..._Click
'    description:   occurs when the user presses and then releases a mouse button over an object.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub mnuClearWindow_Click()
    On Error GoTo errMnuClearWindow_Click

    Const FUNCTION_NAME = "mnuClearWindow_Click"
    
    rtfSQL.ReadOnly = False
    rtfSQL.Text = ""
    rtfSQL.ReadOnly = True
    
    rtfSQL.SetSelectionIndexes 0, 0
    rtfSQL.setRangeTextColor 0, 0, RGB(0, 0, 0)
    
    If rtfSQL.Visible Then rtfSQL.SetFocus
    
    Exit Sub
    
errMnuClearWindow_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub mnuSelectAll_Click()
    On Error GoTo errMnuSelectAll_Click

    Const FUNCTION_NAME = "mnuSelectAll_Click"
    
    'select whole statement
    rtfSQL.SetSelectionIndexes 0, Len(rtfSQL.Text)
    
    Exit Sub
    
errMnuSelectAll_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub rtfSQL_FontChange()
    On Error GoTo errRtfSQL_FontChange

    Const FUNCTION_NAME = "rtfSQL_FontChange"

    'Save Font
    m_oGlobalInfo.userProfile.setStatusFont rtfSQL.Font.Name, _
                                      rtfSQL.Font.Bold, _
                                      rtfSQL.Font.Italic, _
                                      rtfSQL.Font.Size, _
                                      rtfSQL.Font.Strikethrough, _
                                      rtfSQL.Font.Underline

    Exit Sub

errRtfSQL_FontChange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub


